Debian Bug report logs - #646977
libncurses5-dev: "Multi-Arch: same" but files differ across architectures

version graph

Package: libncurses5-dev; Maintainer for libncurses5-dev is Craig Small <csmall@debian.org>; Source for libncurses5-dev is src:ncurses.

Reported by: Jakub Wilk <jwilk@debian.org>

Date: Fri, 28 Oct 2011 20:03:02 UTC

Severity: normal

Merged with 646761

Found in version ncurses/5.9-2

Fixed in version ncurses/5.9-3

Done: Sven Joachim <svenjoac@gmx.de>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, jwilk@debian.org, Craig Small <csmall@debian.org>:
Bug#646977; Package libncurses5-dev. (Fri, 28 Oct 2011 20:03:05 GMT) Full text and rfc822 format available.

Message #3 received at submit@bugs.debian.org (full text, mbox):

From: Jakub Wilk <jwilk@debian.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: libncurses5-dev: "Multi-Arch: same" but files differ across architectures
Date: Fri, 28 Oct 2011 21:58:59 +0200
[Message part 1 (text/plain, inline)]
Package: libncurses5-dev
Version: 5.9-2
Severity: normal
User: multiarch-devel@lists.alioth.debian.org
Usertags: multiarch

libncurses5-dev is marked as "Multi-Arch: same" but some of the files it 
ships differ across architectures:

/usr/include/etip.h (amd64 != all the rest)
/usr/include/term.h (kfreebsd-* != linux architectures)
/usr/include/curses.h (different on every architecture)

The attached is diff between amd64 and kfreebsd-amd64, which should 
show the nature of all discrepancies.

-- 
Jakub Wilk
[libncurses5-dev.archdiff (text/plain, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Craig Small <csmall@debian.org>:
Bug#646977; Package libncurses5-dev. (Fri, 28 Oct 2011 20:30:09 GMT) Full text and rfc822 format available.

Acknowledgement sent to Sven Joachim <svenjoac@gmx.de>:
Extra info received and forwarded to list. Copy sent to Craig Small <csmall@debian.org>. (Fri, 28 Oct 2011 20:30:09 GMT) Full text and rfc822 format available.

Message #8 received at 646977@bugs.debian.org (full text, mbox):

From: Sven Joachim <svenjoac@gmx.de>
To: Jakub Wilk <jwilk@debian.org>
Cc: 646977@bugs.debian.org
Subject: Re: Bug#646977: libncurses5-dev: "Multi-Arch: same" but files differ across architectures
Date: Fri, 28 Oct 2011 22:26:01 +0200
merge 646761 646977
thanks

On 2011-10-28 21:58 +0200, Jakub Wilk wrote:

> Package: libncurses5-dev
> Version: 5.9-2
> Severity: normal
> User: multiarch-devel@lists.alioth.debian.org
> Usertags: multiarch
>
> libncurses5-dev is marked as "Multi-Arch: same" but some of the files
> it ships differ across architectures:

> /usr/include/etip.h (amd64 != all the rest)
> /usr/include/term.h (kfreebsd-* != linux architectures)
> /usr/include/curses.h (different on every architecture)

I had noticed the latter two myself in the meantime, but I don't have an
explanation for the first ATM.

> --- libncurses5-dev_5.9-2_amd64/usr/include/etip.h
> +++ libncurses5-dev_5.9-2_kfreebsd-amd64/usr/include/etip.h
> @@ -62,7 +62,7 @@
>  #endif
>  
>  #ifndef ETIP_NEEDS_MATH_H
> -#define ETIP_NEEDS_MATH_H 1
> +#define ETIP_NEEDS_MATH_H 0
>  #endif
>  
>  #ifndef ETIP_NEEDS_MATH_EXCEPTION

The value of ETIP_NEEDS_MATH_H is probably dependent on the build
environment, rather than on the architecture.  Craig, do you have any
build logs?

Cheers,
       Sven




Merged 646761 646977. Request was from Sven Joachim <svenjoac@gmx.de> to control@bugs.debian.org. (Fri, 28 Oct 2011 20:30:12 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Craig Small <csmall@debian.org>:
Bug#646977; Package libncurses5-dev. (Fri, 28 Oct 2011 21:10:30 GMT) Full text and rfc822 format available.

Acknowledgement sent to Sven Joachim <svenjoac@gmx.de>:
Extra info received and forwarded to list. Copy sent to Craig Small <csmall@debian.org>. (Fri, 28 Oct 2011 21:10:39 GMT) Full text and rfc822 format available.

Message #15 received at 646977@bugs.debian.org (full text, mbox):

From: Sven Joachim <svenjoac@gmx.de>
To: 646977@bugs.debian.org
Cc: Jakub Wilk <jwilk@debian.org>
Subject: Re: Bug#646977: libncurses5-dev: "Multi-Arch: same" but files differ across architectures
Date: Fri, 28 Oct 2011 23:05:54 +0200
On 2011-10-28 22:26 +0200, Sven Joachim wrote:

> On 2011-10-28 21:58 +0200, Jakub Wilk wrote:
>
>> --- libncurses5-dev_5.9-2_amd64/usr/include/etip.h
>> +++ libncurses5-dev_5.9-2_kfreebsd-amd64/usr/include/etip.h
>> @@ -62,7 +62,7 @@
>>  #endif
>>  
>>  #ifndef ETIP_NEEDS_MATH_H
>> -#define ETIP_NEEDS_MATH_H 1
>> +#define ETIP_NEEDS_MATH_H 0
>>  #endif
>>  
>>  #ifndef ETIP_NEEDS_MATH_EXCEPTION
>
> The value of ETIP_NEEDS_MATH_H is probably dependent on the build
> environment, rather than on the architecture.  Craig, do you have any
> build logs?

I've noticed the difference myself, ETIP_NEEDS_MATH_H is #defined as 0
when building in pbuilder but 1 when building on my normal system.  The
obj/config.log file in the pbuilder build reveals a problem:

,----
| configure:17630: checking for special defines needed for etip.h
| configure:17656: /usr/bin/g++ -c -g -O2 -fstack-protector --param=ssp-buffer-size=4 -Wformat -Wformat-security -Werror=format-security -I/tmp/buildd/ncurses-5.9/c++ -I/tmp/buildd/ncurses-5.9/menu -I/tmp/buildd/ncurses-5.9/include -D_FORTIFY_SOURCE=2 -D_GNU_SOURCE -D_FILE_OFFSET_BITS=64  -DNDEBUG conftest.cc >&5
| In file included from configure:17644:0:
| /tmp/buildd/ncurses-5.9/c++/etip.h.in:116:25: fatal error: ncurses_dll.h: No such file or directory
| compilation terminated.
| configure:17659: $? = 1
| configure: failed program was:
| #line 17642 "configure"
| #include "confdefs.h"
| 
| #include <etip.h.in>
| 
| int
| main ()
| {
| 
|   ;
|   return 0;
| }
| configure:17656: /usr/bin/g++ -c -g -O2 -fstack-protector --param=ssp-buffer-size=4 -Wformat -Wformat-security -Werror=format-security -I/tmp/buildd/ncurses-5.9/c++ -I/tmp/buildd/ncurses-5.9/menu -I/tmp/buildd/ncurses-5.9/include -DETIP_NEEDS_MATH_EXCEPTION -D_FORTIFY_SOURCE=2 -D_GNU_SOURCE -D_FILE_OFFSET_BITS=64  -DNDEBUG conftest.cc >&5
| In file included from configure:17644:0:
| /tmp/buildd/ncurses-5.9/c++/etip.h.in:116:25: fatal error: ncurses_dll.h: No such file or directory
| compilation terminated.
| configure:17659: $? = 1
| configure: failed program was:
| #line 17642 "configure"
| #include "confdefs.h"
| 
| #include <etip.h.in>
| 
| int
| main ()
| {
| 
|   ;
|   return 0;
| }
| configure:17656: /usr/bin/g++ -c -g -O2 -fstack-protector --param=ssp-buffer-size=4 -Wformat -Wformat-security -Werror=format-security -I/tmp/buildd/ncurses-5.9/c++ -I/tmp/buildd/ncurses-5.9/menu -I/tmp/buildd/ncurses-5.9/include -DETIP_NEEDS_MATH_H -D_FORTIFY_SOURCE=2 -D_GNU_SOURCE -D_FILE_OFFSET_BITS=64  -DNDEBUG conftest.cc >&5
| In file included from configure:17644:0:
| /tmp/buildd/ncurses-5.9/c++/etip.h.in:116:25: fatal error: ncurses_dll.h: No such file or directory
| compilation terminated.
| configure:17659: $? = 1
| configure: failed program was:
| #line 17642 "configure"
| #include "confdefs.h"
| 
| #include <etip.h.in>
| 
| int
| main ()
| {
| 
|   ;
|   return 0;
| }
| configure:17656: /usr/bin/g++ -c -g -O2 -fstack-protector --param=ssp-buffer-size=4 -Wformat -Wformat-security -Werror=format-security -I/tmp/buildd/ncurses-5.9/c++ -I/tmp/buildd/ncurses-5.9/menu -I/tmp/buildd/ncurses-5.9/include -DETIP_NEEDS_MATH_H -DETIP_NEEDS_MATH_EXCEPTION -D_FORTIFY_SOURCE=2 -D_GNU_SOURCE -D_FILE_OFFSET_BITS=64  -DNDEBUG conftest.cc >&5
| In file included from configure:17644:0:
| /tmp/buildd/ncurses-5.9/c++/etip.h.in:116:25: fatal error: ncurses_dll.h: No such file or directory
| compilation terminated.
| configure:17659: $? = 1
| configure: failed program was:
| #line 17642 "configure"
| #include "confdefs.h"
| 
| #include <etip.h.in>
| 
| int
| main ()
| {
| 
|   ;
|   return 0;
| }
| configure:17686: result: none
`----

Since we build out of tree, the correct include directory would have
been /tmp/buildd/ncurses-5.9/obj/include rather than
/tmp/buildd/ncurses-5.9/include.

When building on my normal system, this problem is hidden because
libncurses5-dev is installed, and so the ncurses_dll.h copy in
/usr/include is used:

,----
| configure:17630: checking for special defines needed for etip.h
| configure:17656: /usr/bin/g++ -c -g -O2 -fstack-protector --param=ssp-buffer-size=4 -Wformat -Wformat-security -Werror=format-security -I/usr/local/src/deb-src/ncurses/ncurses/c++ -I/usr/local/src/deb-src/ncurses/ncurses/menu -I/usr/local/src/deb-src/ncurses/ncurses/include -D_FORTIFY_SOURCE=2 -D_GNU_SOURCE -D_FILE_OFFSET_BITS=64  -DNDEBUG conftest.cc >&5
| configure:17659: $? = 0
| configure:17662: test -s conftest.o
| configure:17665: $? = 0
| configure:17656: /usr/bin/g++ -c -g -O2 -fstack-protector --param=ssp-buffer-size=4 -Wformat -Wformat-security -Werror=format-security -I/usr/local/src/deb-src/ncurses/ncurses/c++ -I/usr/local/src/deb-src/ncurses/ncurses/menu -I/usr/local/src/deb-src/ncurses/ncurses/include -DETIP_NEEDS_MATH_H -D_FORTIFY_SOURCE=2 -D_GNU_SOURCE -D_FILE_OFFSET_BITS=64  -DNDEBUG conftest.cc >&5
| configure:17659: $? = 0
| configure:17662: test -s conftest.o
| configure:17665: $? = 0
| configure:17686: result: MATH_H 
`----

Cheers,
       Sven




Information forwarded to debian-bugs-dist@lists.debian.org, Craig Small <csmall@debian.org>:
Bug#646977; Package libncurses5-dev. (Sat, 29 Oct 2011 07:51:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jakub Wilk <jwilk@debian.org>:
Extra info received and forwarded to list. Copy sent to Craig Small <csmall@debian.org>. (Sat, 29 Oct 2011 07:51:03 GMT) Full text and rfc822 format available.

Message #20 received at 646977@bugs.debian.org (full text, mbox):

From: Jakub Wilk <jwilk@debian.org>
To: 646977@bugs.debian.org
Subject: Re: Bug#646977: libncurses5-dev: "Multi-Arch: same" but files differ across architectures
Date: Sat, 29 Oct 2011 09:48:07 +0200
* Jakub Wilk <jwilk@debian.org>, 2011-10-28, 21:58:
>/usr/include/term.h (kfreebsd-* != linux architectures)

Just for completeness, term.h on hurd-i386 is the same as on kfreebsd-*.

-- 
Jakub Wilk




Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#646977; Package libncurses5-dev. (Sun, 30 Oct 2011 23:18:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Craig Small <csmall@debian.org>:
Extra info received and forwarded to list. (Sun, 30 Oct 2011 23:18:03 GMT) Full text and rfc822 format available.

Message #25 received at 646977@bugs.debian.org (full text, mbox):

From: Craig Small <csmall@debian.org>
To: Sven Joachim <svenjoac@gmx.de>, 646977@bugs.debian.org
Cc: Jakub Wilk <jwilk@debian.org>
Subject: Re: Bug#646977: libncurses5-dev: "Multi-Arch: same" but files differ across architectures
Date: Mon, 31 Oct 2011 10:08:08 +1100
On Fri, Oct 28, 2011 at 11:05:54PM +0200, Sven Joachim wrote:
> > The value of ETIP_NEEDS_MATH_H is probably dependent on the build
> > environment, rather than on the architecture.  Craig, do you have any
> > build logs?
i do, I would not of used pbuilder most likely.

> | /tmp/buildd/ncurses-5.9/c++/etip.h.in:116:25: fatal error: ncurses_dll.h: No such file or directory
> | compilation terminated.
> | configure:17659: $? = 1
How strange you get this error.

configure:17630: checking for special defines needed for etip.h
configure:17656: /usr/bin/g++ -c -g -O2 -fstack-protector --param=ssp-buffer-size=4 -D_FORTIFY_SOURCE=2 -Wformat -Wformat-security -Werror=format-security -I/home/csmall/debian/ncurses/ncurses/c++ -I/home/csmall/debian/ncurses/ncurses/menu -I/home/csmall/debian/ncurses/ncurses/include  -D_GNU_SOURCE -DNDEBUG conftest.cc >&5
configure:17659: $? = 0

> When building on my normal system, this problem is hidden because
> libncurses5-dev is installed, and so the ncurses_dll.h copy in
> /usr/include is used:
That seems wrong to me.  It should be using "its own" header file,
shouldn't it?

 - Craig

-- 
Craig Small VK2XLZ   http://enc.com.au/          csmall at : enc.com.au
Debian GNU/Linux     http://www.debian.org/      csmall at : debian.org
old fingerprint:     1C1B D893 1418 2AF4 45EE  95CB C76C E5AC 12CA DFA5
NEW fingerprint:     5D2F B320 B825 D939 04D2  0519 3938 F96B DF50 FEA5




Information forwarded to debian-bugs-dist@lists.debian.org, Craig Small <csmall@debian.org>:
Bug#646977; Package libncurses5-dev. (Sun, 30 Oct 2011 23:24:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Thomas Dickey <dickey@his.com>:
Extra info received and forwarded to list. Copy sent to Craig Small <csmall@debian.org>. (Sun, 30 Oct 2011 23:24:05 GMT) Full text and rfc822 format available.

Message #30 received at 646977@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@his.com>
To: Craig Small <csmall@debian.org>, 646977@bugs.debian.org
Cc: Sven Joachim <svenjoac@gmx.de>, Jakub Wilk <jwilk@debian.org>
Subject: Re: Bug#646977: libncurses5-dev: "Multi-Arch: same" but files differ across architectures
Date: Sun, 30 Oct 2011 19:19:18 -0400 (EDT)
On Mon, 31 Oct 2011, Craig Small wrote:

> On Fri, Oct 28, 2011 at 11:05:54PM +0200, Sven Joachim wrote:
>>> The value of ETIP_NEEDS_MATH_H is probably dependent on the build
>>> environment, rather than on the architecture.  Craig, do you have any
>>> build logs?
> i do, I would not of used pbuilder most likely.
>
>> | /tmp/buildd/ncurses-5.9/c++/etip.h.in:116:25: fatal error: ncurses_dll.h: No such file or directory
>> | compilation terminated.
>> | configure:17659: $? = 1
> How strange you get this error.
>
> configure:17630: checking for special defines needed for etip.h
> configure:17656: /usr/bin/g++ -c -g -O2 -fstack-protector --param=ssp-buffer-size=4 -D_FORTIFY_SOURCE=2 -Wformat -Wformat-security -Werror=format-security -I/home/csmall/debian/ncurses/ncurses/c++ -I/home/csmall/debian/ncurses/ncurses/menu -I/home/csmall/debian/ncurses/ncurses/include  -D_GNU_SOURCE -DNDEBUG conftest.cc >&5
> configure:17659: $? = 0
>
>> When building on my normal system, this problem is hidden because
>> libncurses5-dev is installed, and so the ncurses_dll.h copy in
>> /usr/include is used:
> That seems wrong to me.  It should be using "its own" header file,
> shouldn't it?

It should.  I saw something of that sort yesterday, and made a note to 
check on it.  But I've spent most of the weekend working on a change to 
the way _XOPEN_SOURCE is defined (lots of builds to retest).  So it'll 
probably be unresolved in tonight's (expected) patch.

-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net




Added tag(s) pending. Request was from Sven Joachim <svenjoac@gmx.de> to control@bugs.debian.org. (Mon, 31 Oct 2011 16:39:09 GMT) Full text and rfc822 format available.

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Tue, 29 Nov 2011 07:39:09 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Fri Apr 25 08:12:04 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.